Class AbstractClient_v0_3

java.lang.Object
org.a2aproject.sdk.compat03.client.AbstractClient_v0_3
Direct Known Subclasses:
Client_v0_3

public abstract class AbstractClient_v0_3 extends Object
Abstract class representing an A2A client. Provides a standard set of methods for interacting with an A2A agent, regardless of the underlying transport protocol. It supports sending messages, managing tasks, and handling event streams.
  • Constructor Details

  • Method Details

    • sendMessage

      public void sendMessage(Message_v0_3 request) throws A2AClientException_v0_3
      Send a message to the remote agent. This method will automatically use the streaming or non-streaming approach as determined by the server's agent card and the client configuration. The configured client consumers will be used to handle messages, tasks, and update events received from the remote agent. The configured streaming error handler will be used if an error occurs during streaming. The configured client push notification configuration will get used for streaming.
      Parameters:
      request - the message
      Throws:
      A2AClientException_v0_3 - if sending the message fails for any reason
    • sendMessage

      public abstract void sendMessage(Message_v0_3 request, @Nullable ClientCallContext_v0_3 context) throws A2AClientException_v0_3
      Send a message to the remote agent. This method will automatically use the streaming or non-streaming approach as determined by the server's agent card and the client configuration. The configured client consumers will be used to handle messages, tasks, and update events received from the remote agent. The configured streaming error handler will be used if an error occurs during streaming. The configured client push notification configuration will get used for streaming.
      Parameters:
      request - the message
      context - optional client call context for the request (may be null)
      Throws:
      A2AClientException_v0_3 - if sending the message fails for any reason
    • sendMessage

      public void sendMessage(Message_v0_3 request, List<BiConsumer<ClientEvent_v0_3, AgentCard_v0_3>> consumers, Consumer<Throwable> streamingErrorHandler) throws A2AClientException_v0_3
      Send a message to the remote agent. This method will automatically use the streaming or non-streaming approach as determined by the server's agent card and the client configuration. The specified client consumers will be used to handle messages, tasks, and update events received from the remote agent. The specified streaming error handler will be used if an error occurs during streaming. The configured client push notification configuration will get used for streaming.
      Parameters:
      request - the message
      consumers - a list of consumers to pass responses from the remote agent to
      streamingErrorHandler - an error handler that should be used for the streaming case if an error occurs
      Throws:
      A2AClientException_v0_3 - if sending the message fails for any reason
    • sendMessage

      public abstract void sendMessage(Message_v0_3 request, List<BiConsumer<ClientEvent_v0_3, AgentCard_v0_3>> consumers, Consumer<Throwable> streamingErrorHandler, @Nullable ClientCallContext_v0_3 context) throws A2AClientException_v0_3
      Send a message to the remote agent. This method will automatically use the streaming or non-streaming approach as determined by the server's agent card and the client configuration. The specified client consumers will be used to handle messages, tasks, and update events received from the remote agent. The specified streaming error handler will be used if an error occurs during streaming. The configured client push notification configuration will get used for streaming.
      Parameters:
      request - the message
      consumers - a list of consumers to pass responses from the remote agent to
      streamingErrorHandler - an error handler that should be used for the streaming case if an error occurs
      context - optional client call context for the request (may be null)
      Throws:
      A2AClientException_v0_3 - if sending the message fails for any reason
    • sendMessage

      public void sendMessage(Message_v0_3 request, PushNotificationConfig_v0_3 pushNotificationConfiguration, Map<String,Object> metadata) throws A2AClientException_v0_3
      Send a message to the remote agent. This method will automatically use the streaming or non-streaming approach as determined by the server's agent card and the client configuration. The configured client consumers will be used to handle messages, tasks, and update events received from the remote agent. The configured streaming error handler will be used if an error occurs during streaming.
      Parameters:
      request - the message
      pushNotificationConfiguration - the push notification configuration that should be used if the streaming approach is used
      metadata - the optional metadata to include when sending the message
      Throws:
      A2AClientException_v0_3 - if sending the message fails for any reason
    • sendMessage

      public abstract void sendMessage(Message_v0_3 request, PushNotificationConfig_v0_3 pushNotificationConfiguration, Map<String,Object> metadata, @Nullable ClientCallContext_v0_3 context) throws A2AClientException_v0_3
      Send a message to the remote agent. This method will automatically use the streaming or non-streaming approach as determined by the server's agent card and the client configuration. The configured client consumers will be used to handle messages, tasks, and update events received from the remote agent. The configured streaming error handler will be used if an error occurs during streaming.
      Parameters:
      request - the message
      pushNotificationConfiguration - the push notification configuration that should be used if the streaming approach is used
      metadata - the optional metadata to include when sending the message
      context - optional client call context for the request (may be null)
      Throws:
      A2AClientException_v0_3 - if sending the message fails for any reason
    • getTask

      public Task_v0_3 getTask(TaskQueryParams_v0_3 request) throws A2AClientException_v0_3
      Retrieve the current state and history of a specific task.
      Parameters:
      request - the task query parameters specifying which task to retrieve
      Returns:
      the task
      Throws:
      A2AClientException_v0_3 - if retrieving the task fails for any reason
    • getTask

      public abstract Task_v0_3 getTask(TaskQueryParams_v0_3 request, @Nullable ClientCallContext_v0_3 context) throws A2AClientException_v0_3
      Retrieve the current state and history of a specific task.
      Parameters:
      request - the task query parameters specifying which task to retrieve
      context - optional client call context for the request (may be null)
      Returns:
      the task
      Throws:
      A2AClientException_v0_3 - if retrieving the task fails for any reason
    • cancelTask

      public Task_v0_3 cancelTask(TaskIdParams_v0_3 request) throws A2AClientException_v0_3
      Request the agent to cancel a specific task.
      Parameters:
      request - the task ID parameters specifying which task to cancel
      Returns:
      the cancelled task
      Throws:
      A2AClientException_v0_3 - if cancelling the task fails for any reason
    • cancelTask

      public abstract Task_v0_3 cancelTask(TaskIdParams_v0_3 request, @Nullable ClientCallContext_v0_3 context) throws A2AClientException_v0_3
      Request the agent to cancel a specific task.
      Parameters:
      request - the task ID parameters specifying which task to cancel
      context - optional client call context for the request (may be null)
      Returns:
      the cancelled task
      Throws:
      A2AClientException_v0_3 - if cancelling the task fails for any reason
    • setTaskPushNotificationConfiguration

      public TaskPushNotificationConfig_v0_3 setTaskPushNotificationConfiguration(TaskPushNotificationConfig_v0_3 request) throws A2AClientException_v0_3
      Set or update the push notification configuration for a specific task.
      Parameters:
      request - the push notification configuration to set for the task
      Returns:
      the configured TaskPushNotificationConfig
      Throws:
      A2AClientException_v0_3 - if setting the task push notification configuration fails for any reason
    • setTaskPushNotificationConfiguration

      public abstract TaskPushNotificationConfig_v0_3 setTaskPushNotificationConfiguration(TaskPushNotificationConfig_v0_3 request, @Nullable ClientCallContext_v0_3 context) throws A2AClientException_v0_3
      Set or update the push notification configuration for a specific task.
      Parameters:
      request - the push notification configuration to set for the task
      context - optional client call context for the request (may be null)
      Returns:
      the configured TaskPushNotificationConfig
      Throws:
      A2AClientException_v0_3 - if setting the task push notification configuration fails for any reason
    • getTaskPushNotificationConfiguration

      public TaskPushNotificationConfig_v0_3 getTaskPushNotificationConfiguration(GetTaskPushNotificationConfigParams_v0_3 request) throws A2AClientException_v0_3
      Retrieve the push notification configuration for a specific task.
      Parameters:
      request - the parameters specifying which task's notification config to retrieve
      Returns:
      the task push notification config
      Throws:
      A2AClientException_v0_3 - if getting the task push notification config fails for any reason
    • getTaskPushNotificationConfiguration

      public abstract TaskPushNotificationConfig_v0_3 getTaskPushNotificationConfiguration(GetTaskPushNotificationConfigParams_v0_3 request, @Nullable ClientCallContext_v0_3 context) throws A2AClientException_v0_3
      Retrieve the push notification configuration for a specific task.
      Parameters:
      request - the parameters specifying which task's notification config to retrieve
      context - optional client call context for the request (may be null)
      Returns:
      the task push notification config
      Throws:
      A2AClientException_v0_3 - if getting the task push notification config fails for any reason
    • listTaskPushNotificationConfigurations

      public List<TaskPushNotificationConfig_v0_3> listTaskPushNotificationConfigurations(ListTaskPushNotificationConfigParams_v0_3 request) throws A2AClientException_v0_3
      Retrieve the list of push notification configurations for a specific task.
      Parameters:
      request - the parameters specifying which task's notification configs to retrieve
      Returns:
      the list of task push notification configs
      Throws:
      A2AClientException_v0_3 - if getting the task push notification configs fails for any reason
    • listTaskPushNotificationConfigurations

      public abstract List<TaskPushNotificationConfig_v0_3> listTaskPushNotificationConfigurations(ListTaskPushNotificationConfigParams_v0_3 request, @Nullable ClientCallContext_v0_3 context) throws A2AClientException_v0_3
      Retrieve the list of push notification configurations for a specific task.
      Parameters:
      request - the parameters specifying which task's notification configs to retrieve
      context - optional client call context for the request (may be null)
      Returns:
      the list of task push notification configs
      Throws:
      A2AClientException_v0_3 - if getting the task push notification configs fails for any reason
    • deleteTaskPushNotificationConfigurations

      public void deleteTaskPushNotificationConfigurations(DeleteTaskPushNotificationConfigParams_v0_3 request) throws A2AClientException_v0_3
      Delete the list of push notification configurations for a specific task.
      Parameters:
      request - the parameters specifying which task's notification configs to delete
      Throws:
      A2AClientException_v0_3 - if deleting the task push notification configs fails for any reason
    • deleteTaskPushNotificationConfigurations

      public abstract void deleteTaskPushNotificationConfigurations(DeleteTaskPushNotificationConfigParams_v0_3 request, @Nullable ClientCallContext_v0_3 context) throws A2AClientException_v0_3
      Delete the list of push notification configurations for a specific task.
      Parameters:
      request - the parameters specifying which task's notification configs to delete
      context - optional client call context for the request (may be null)
      Throws:
      A2AClientException_v0_3 - if deleting the task push notification configs fails for any reason
    • resubscribe

      public void resubscribe(TaskIdParams_v0_3 request) throws A2AClientException_v0_3
      Resubscribe to a task's event stream. This is only available if both the client and server support streaming. The configured client consumers will be used to handle messages, tasks, and update events received from the remote agent. The configured streaming error handler will be used if an error occurs during streaming.
      Parameters:
      request - the parameters specifying which task's notification configs to delete
      Throws:
      A2AClientException_v0_3 - if resubscribing fails for any reason
    • resubscribe

      public abstract void resubscribe(TaskIdParams_v0_3 request, @Nullable ClientCallContext_v0_3 context) throws A2AClientException_v0_3
      Resubscribe to a task's event stream. This is only available if both the client and server support streaming. The configured client consumers will be used to handle messages, tasks, and update events received from the remote agent. The configured streaming error handler will be used if an error occurs during streaming.
      Parameters:
      request - the parameters specifying which task's notification configs to delete
      context - optional client call context for the request (may be null)
      Throws:
      A2AClientException_v0_3 - if resubscribing fails for any reason
    • resubscribe

      public void resubscribe(TaskIdParams_v0_3 request, List<BiConsumer<ClientEvent_v0_3, AgentCard_v0_3>> consumers, Consumer<Throwable> streamingErrorHandler) throws A2AClientException_v0_3
      Resubscribe to a task's event stream. This is only available if both the client and server support streaming. The specified client consumers will be used to handle messages, tasks, and update events received from the remote agent. The specified streaming error handler will be used if an error occurs during streaming.
      Parameters:
      request - the parameters specifying which task's notification configs to delete
      consumers - a list of consumers to pass responses from the remote agent to
      streamingErrorHandler - an error handler that should be used for the streaming case if an error occurs
      Throws:
      A2AClientException_v0_3 - if resubscribing fails for any reason
    • resubscribe

      public abstract void resubscribe(TaskIdParams_v0_3 request, List<BiConsumer<ClientEvent_v0_3, AgentCard_v0_3>> consumers, Consumer<Throwable> streamingErrorHandler, @Nullable ClientCallContext_v0_3 context) throws A2AClientException_v0_3
      Resubscribe to a task's event stream. This is only available if both the client and server support streaming. The specified client consumers will be used to handle messages, tasks, and update events received from the remote agent. The specified streaming error handler will be used if an error occurs during streaming.
      Parameters:
      request - the parameters specifying which task's notification configs to delete
      consumers - a list of consumers to pass responses from the remote agent to
      streamingErrorHandler - an error handler that should be used for the streaming case if an error occurs
      context - optional client call context for the request (may be null)
      Throws:
      A2AClientException_v0_3 - if resubscribing fails for any reason
    • getAgentCard

      public AgentCard_v0_3 getAgentCard() throws A2AClientException_v0_3
      Retrieve the AgentCard.
      Returns:
      the AgentCard
      Throws:
      A2AClientException_v0_3 - if retrieving the agent card fails for any reason
    • getAgentCard

      public abstract AgentCard_v0_3 getAgentCard(@Nullable ClientCallContext_v0_3 context) throws A2AClientException_v0_3
      Retrieve the AgentCard.
      Parameters:
      context - optional client call context for the request (may be null)
      Returns:
      the AgentCard
      Throws:
      A2AClientException_v0_3 - if retrieving the agent card fails for any reason
    • close

      public abstract void close()
      Close the transport and release any associated resources.
    • getStreamingErrorHandler

      public @Nullable Consumer<Throwable> getStreamingErrorHandler()
      Get the error handler that should be used during streaming.
      Returns:
      the streaming error handler